/**
 * Copyright (c) 2010-2012 EBMWebsourcing, 2012-2013 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.component.framework.util;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import java.io.ByteArrayInputStream;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.junit.Test;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

/**
 * @author Mathieu Carrolle - EBM WebSourcing
 */
public class XMLUtilTest {
    final String baseMsg = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "<getResponse>"
            + "<!-- comment after getResponse before base node -->" + "<test>linux rocks</test>"
            + "<base><!-- yet xml comment -->${content}</base>" + "</getResponse>";

    @Test
    public void testFindVariable() throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document resultDoc = builder.parse(new ByteArrayInputStream(this.baseMsg.getBytes()));

        assertNull("Check node not found",
                XMLUtil.findVariable(resultDoc.getChildNodes(), "${attachments}"));
        Node nodeFound = XMLUtil.findVariable(resultDoc.getChildNodes(), "${content}");

        assertNotNull("Check node found", nodeFound);
        assertEquals("Check node type", Node.TEXT_NODE, nodeFound.getNodeType());
        assertEquals("Check node parent", resultDoc.createElement("base").toString(), nodeFound
                .getParentNode().toString());
    }
}
